#include <stdlib.h>



#define total 10
#define colon 301
#define ligne 401

struct ghost {
	int une;
	int col;
	int row;
	struct ghost * back;
	struct ghost * next;
} ;

struct ghost * head;
struct ghost * tail;
struct ghost * ici;

struct ghost * array[total];
struct ghost * matrix[colon][ligne];

/*
void loop(void)
{
			ici = head;
			while (ici->next != NULL)
			{
				...

				ici = ici->next;
			}
}
*/


void creer (void)
{
	if (tail == 0)
	{
		head = (struct ghost *) malloc(sizeof(struct ghost));
		head->back = NULL;
		head->next = NULL;
		tail = head;
	}
	tail->next = (struct ghost *) malloc(sizeof(struct ghost));
	tail->next->back = tail;
	tail->next->next = NULL;
	tail = tail->next;
	return;
}

void detruire (struct ghost * mort)
{
	if ((mort->back == head)||(mort->next == head))
	{
		return;
	}
	if ((mort == tail)||(mort == head))
	{
		if (mort == tail)
		{
			tail = mort->back;
			mort->back->next = NULL;
			free(mort);
		}
		if (mort == head)
		{
			head = mort->next;
			mort->next->back = NULL;
			free(mort);
		}
	} else {
		mort->back->next = mort->next;
		mort->next->back = mort->back;
		free(mort);
	}
}



//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================

void element(struct ghost * point)
{
	struct ghost * down,*up,*left,*right, *dleft, *dright, *uleft, *uright;
//=======================================================================================
//===============================get 8 direction if there available======================
//=======================================================================================
	if (point->row > 1)
	{	down = matrix[point->col][point->row-1];
	} else {	down = point;	}
	if (point->row < 399)
	{	up = matrix[point->col][point->row+1];
	} else {	up = point;	}
	if (point->col > 1)
	{	left = matrix[point->col-1][point->row];
	} else {	left = point;	}
	if (point->col < 299)
	{	right = matrix[point->col+1][point->row];
	} else {	right = point;	}
	if ((point->row > 1)&&(point->col > 1))
	{	dleft = matrix[point->col-1][point->row-1];
	} else {	dleft = point;	}
	if ((point->row < 399)&&(point->col > 1))
	{	uleft = matrix[point->col-1][point->row+1];
	} else {	uleft = point;	}
	if ((point->row > 1)&&(point->col < 299))
	{	dright = matrix[point->col+1][point->row-1];
	} else {	dright = point;	}
	if ((point->row < 399)&&(point->col < 299))
	{	uright = matrix[point->col+1][point->row+1];
	} else {	uright = point;	}
//=========================================================================
//===================== what do we have here ? ============================
//=========================================================================
	switch (point->une)
	{
	//-------------------> earth
		//	the simple element
		case 1:
			if (down != point)
			{if (down == NULL)
			{	if (point->row > 2)
                    		{if (matrix[point->col][point->row-2] == NULL)
				{	if (point->row > 3)
                            		{if (matrix[point->col][point->row-3] == NULL)
					{	matrix[point->col][point->row] = NULL;
						matrix[point->col][point->row-3] = point;
						point->row -= 3;
						break;
					}}
					matrix[point->col][point->row] = NULL;
					matrix[point->col][point->row-2] = point;
					point->row -= 2;
					break;
				}}
				matrix[point->col][point->row] = NULL;
				matrix[point->col][point->row-1] = point;
				point->row -= 1;
				break;
			} else {
            			if (down->une == 2)
				{	matrix[point->col][point->row] = down;
					matrix[point->col][point->row-1] = point;
					point->row -= 1;
					down->row +=1;
					break;
				}
			}}

            		if (dleft != point)
			{if (dleft == NULL)
			{	matrix[point->col][point->row] = NULL;
				matrix[point->col-1][point->row-1] = point;
				point->row -= 1;
				point->col -= 1;
				break;
			}}

            		if (dright != point)
			{if (dright == NULL)
			{	matrix[point->col][point->row] = NULL;
				matrix[point->col+1][point->row-1] = point;
				point->row -= 1;
				point->col += 1;
				break;
			}}
			break;
	//-------------------> water
		//	the tempered element
		case 2:
			if (down != point)
			{if (down == NULL)
			{
				if (point->row > 2)
                                {if (matrix[point->col][point->row-2] == NULL)
				{	matrix[point->col][point->row] = NULL;
					matrix[point->col][point->row-2] = point;
					point->row -= 2;
					break;
				}}
						            
				matrix[point->col][point->row] = NULL;
				matrix[point->col][point->row-1] = point;
				point->row -= 1;
				break;
			}}
                   
			if (left != point)
			{if (left == NULL)
			{	matrix[point->col][point->row] = NULL;
				matrix[point->col-1][point->row] = point;
				point->col -= 1;
				break;
			}}
					
			if (right != point)
			{if (right == NULL)
			{	matrix[point->col][point->row] = NULL;
				matrix[point->col+1][point->row] = point;
				point->col += 1;
				break;
			}}
					
			break;
	//-------------------> wood
		//	the variable element
		case 3:
			if (up != point)
			{if (up != NULL)
			{if (up->une == 1)
			{	matrix[point->col][point->row] = up;
				matrix[point->col][point->row+1] = point;
				point->row += 1;
				up->row -=1;
				break;
			}}}

			if (down != point)
			{if (down == NULL)
			{	matrix[point->col][point->row] = NULL;
				matrix[point->col][point->row-1] = point;
				point->row -= 1;
				break;
			} else {
				if (down->une == 2)	
				{
					if (dleft != point)
					{if (dleft != NULL)
					{if (dleft->une == 3)
					{	break;
					}}}

					if (dright != point)
					{if (dright != NULL)
					{if (dright->une == 3)
					{	break;
					}}}
				matrix[point->col][point->row] = down;
				matrix[point->col][point->row-1] = point;
				point->row -= 1;
				down->row +=1;
				break;
				}
			}}

			if ((left != point)&&(right != point))
			{

			if (left != NULL)
			{if (left->une == 2)
			{if (right == NULL)
			{	matrix[point->col][point->row] = left;
				matrix[point->col-1][point->row] = point;
				point->col -= 1;
				left->col +=1;
				break;
			}}}

			if (right != NULL)
			{if (right->une == 2)
			{if (left == NULL)
			{	matrix[point->col][point->row] = right;
				matrix[point->col+1][point->row] = point;
				point->col += 1;
				right->col -=1;
				break;
			}}}

			}
			break;
	//-------------------> metal
		//	the stable element , when together , they simply dont move
		//	alone they fall directly till they find stable element	
		case 4:
			if (down != point)
			{if (down == NULL)
			{

				if (up != point)
				{if (up != NULL)
				{if (up->une == 4)
				{	break;
				}}}
				if (uleft != point)
				{if (uleft != NULL)
				{if (uleft->une == 4)
				{	break;
				}}}
				if (uright != point)
				{if (uright != NULL)
				{if (uright->une == 4)
				{	break;
				}}}
				if (left != point)
				{if (left != NULL)
				{if (left->une == 4)
				{	break;
				}}}
				if (right != point)
				{if (right != NULL)
				{if (right->une == 4)
				{	break;
				}}}
				if (dleft != point)
				{if (dleft != NULL)
				{if (dleft->une == 4)
				{	break;
				}}}
				if (dright != point)
				{if (dright != NULL)
				{if (dright->une == 4)
				{	break;
				}}}


				matrix[point->col][point->row] = NULL;
				matrix[point->col][point->row-1] = point;
				point->row -= 1;
				break;
			}}
			break;
	//------------------> fire
		//	the transformation element
		case 5:
			break;
	//----------------------------end
	}
//=========================================================================
//===================== why do i have problem ? ============================
//=========================================================================

}

//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
//==========================================================================
